#!/usr/bin/perl

$G{perlLib} = "/home/arimaa/web/arimaa/gameroom";
$G{botGames} = "botGames";

push(@INC, $G{perlLib});

require "cgi.pl";
require "html.pl";
require "cookie.pl";
require "time.pl";
require "data.pl";

CgiPrintHeader();

%c = &CookieRead();

if ($c{sid} ne ""){
  %r = &DataGetSessionRec($c{sid});
}


# A file $G{botGames} contains the information we need to display
# The format of the file is one game per line such as:
#      [bot_testD 2111 vs bot_testA 1333]
#      [bot_testC 1234 vs bot_testB 2133]
# The username of the players and their ratings.
# Once the time of the game is scheduled it will be like:
#      [omar 1998 vs naveed 1861] 45 1071331200
#      [Belbo 1905 vs MrBrain 1591] 47 1071345600
# The first number is called a slot, but is not used in
#   this script. The second number is the timestamp of when
#   the game will start and is displayed by this script.
# Once a game is completed the line will be like this:
#      naveed [omar 1998 vs naveed 1861] 45 1071331200 g 56 4421
#      Belbo [Belbo 1905 vs MrBrain 1591] 47 1071345600 g 30 4424
# The player who won is at the begining of the line. After
#   the timestamp, the reason for the win, number of moves
#   and the game id in the Arimaa gameroom are appended.
# If the game is a draw then the line would be like this:
#      omar naveed [omar 1998 vs naveed 1861] 45 1071331200 d 56 4421

$gmt = "GMT";
if ($r{id} ne ""){ $gmt = "YLT"; }


$fn = "";
if (-e "$G{botGames}"){ $fn = $G{botGames}; }
if ($fn ne ""){
  open(FH, "<$fn");
  foreach $l (<FH>){
    chomp $l;
    if ($roundName eq ""){
      ($roundName) = ($l =~ m/^# *(.*)$/);
    }
    ($win1, $win2, $w, $wr, $b, $br, $s, $ts, $why, $ply, $gid) = ($l =~ m/^(\w+) (\w+) \[(\w+) (\d+) vs (\w+) (\d+)\] (\d+) (\d+) (\w) (\d+) (\d+)/);
    if ($w eq ""){
      ($win1, $w, $wr, $b, $br, $s, $ts, $why, $ply, $gid) = ($l =~ m/^(\w+) \[(\w+) (\d+) vs (\w+) (\d+)\] (\d+) (\d+) (\w) (\d+) (\d+)/);
    }
    if ($w eq ""){
      ($win1, $w, $wr, $b, $br, $s, $ts, $why, $ply, $gid) = ($l =~ m/^(\w+) \[(\w+) (\d+) vs (\w+) (\d+)\]/);
    }
    if ($w eq ""){
      ($w, $wr, $b, $br, $s, $ts) = ($l =~ m/^\[(\w+) (\d+) vs (\w+) (\d+)\] (\d+) (\d+)/);
    }
    if ($w eq ""){
      ($w, $wr, $b, $br) = ($l =~ m/^\[(\w+) (\d+) vs (\w+) (\d+)\]/);
    }
    if ($w eq ""){ next; }

    $wwin = ""; $bwin = "";
    if ($win1 eq $w){
      $wwin = "*";
    }
    if ($win1 eq $b){
      $bwin = "*";
    }
    if ($win2 ne ""){
      $wwin = "="; $bwin = "=";
    }

#    $scheduled = ($ts>0) ? &getDayHrMin($ts - $r{timezone}) : '';
    $scheduled = ($ts>0) ? &getMonDateTime($ts - $r{timezone}) : '';
    $scheduled = ($ply ne "") ? "<a href='javascript:comPage($gid)'>$why $ply</a>" : $scheduled;

    if ($win1 ne ""){
      $clickOnBoard = 1;
    }
    else{
      if ($ts>0){ $gameTimes = 1; }
    }

    $board = <<EOM;
<table background="/arimaa/graphics/BoardWithPiecesIcon.jpg" width=50 height=50 border=0 cellspacing=0 cellpadding=0>
  <tr>
    <td >
<a href="javascript:openGame('$gid','v','w');" >
  <img src="/arimaa/graphics/animals/blank.gif" width=25 height=49 border=0>
</a>
    </td>
    <td >
<a href="javascript:openGame('$gid','v','b');" >
  <img src="/arimaa/graphics/animals/blank.gif" width=25 height=49 border=0>
</a>
    </td>
  </tr>
</table>
EOM

    if ($w eq $b){ 
# If the player is playing him self it means that the player is
#   is getting a bye
      $gameRow = <<EOM;
<tr>
  <td align=right>
    <a href="javascript:playerPage('$w')">$w</a><br><font size=-1>$wr</font>
  </td>
  <td align=center>
    <font size=1>$scheduled</font>$board
  </td>
  <td align=left>bye
  </td>
</tr>
EOM
      next;
    }
    $gameRow = <<EOM;
<tr>
  <td align=right>
    $wwin <a href="javascript:playerPage('$w')">$w</a><br><font size=-1>$wr</font>
  </td>
  <td align=center>
    <font size=1>$scheduled</font>$board
  </td>
  <td align=left>
    <a href="javascript:playerPage('$b')">$b</a> $bwin<br><font size=-1>$br</font>
  </td>
</tr>
EOM

    if ($why eq ""){
      if ($ts eq ""){
        push(@unscheduledGames, $gameRow);
      }
      else{
        push(@scheduledGames, sprintf("%011d %s", $ts, $gameRow));
      }
    }
    else{
      if ($ts eq ""){ $ts = 0; } 
      push(@finishedGames, sprintf("%011d %s", $ts, $gameRow));
    }

# Keep a running total of the player scores
    if ($win1 && $win2){
      $score{$win1} += 0.5;
      $score{$win2} += 0.5;
    }
    else{
      if ($win1){ $score{$win1} += 1; }
      if ($win2){ $score{$win2} += 1; }
    }
    if ($score{$w} eq ""){ $score{$w} = 0; }
    if ($score{$b} eq ""){ $score{$b} = 0; }

# Keep a list of the player ratings
    if ($wr > 0){ $rating{$w} = $wr; }
    if ($br > 0){ $rating{$b} = $br; }

  }
  close FH;

# Compute the stanadings from the score
  while(($k, $v) = each(%score)){
    $standings = <<EOM;
<tr>
<td align=center>$v</td>
<td><a href="javascript:playerPage('$k')">$k</a></td>
<td align=right><font size=-1>$rating{$k}</font></td>
</tr>
EOM
    push(@standings, sprintf("%05d %s", $v*2, $standings));
  }
  @standings = sort(@standings);
  @standings = reverse(@standings);
  grep { s/^\d+ //; } @standings;
  $standings = join('', @standings);

  if ($standings){
    $standings = <<EOM;
<td> </td>
<td valign=top>
  <table border=0>
<tr><td colspan=3 align=center><b>Standings</b></td></tr>
<tr>
  <td>Score</td> <td>Player</td> <td>Rating</td>
</tr>
<tr><td colspan=3> </td></tr>
$standings
<tr><td colspan=3> </td></tr>
<tr><td colspan=3 align=center><font size=1>Ratings as of Jan 1st 2004</td></tr>
  </table>
</td>
EOM
  }

  if ($clickOnBoard){
    $clickOnBoard = <<EOM;
  <tr>
    <td></td>
    <td colspan=2 align=left>
<b>
<font size=-2>
Click on board<br>to view game
</font>
</b>
    </td>
  </tr>
EOM
  }

  if ($gameTimes){
    $gameTimes = <<EOM;
  <tr>
    <td></td>
    <td colspan=2 align=left>
<font size=-2>
Times are in $gmt
</font>
    </td>
  </tr>
EOM
  }

  @scheduledGames = sort(@scheduledGames);
  @finishedGames = sort(@finishedGames);

# Dont reverse the scheduled games
#  @scheduledGames = reverse(@scheduledGames);
  @finishedGames = reverse(@finishedGames);

  grep { s/^\d+ //; } @scheduledGames;
  grep { s/^\d+ //; } @finishedGames;

  $scheduledGames = join("\n", @scheduledGames) . join("\n", @unscheduledGames);
  $finishedGames = join("\n", @finishedGames);

  if ($scheduledGames){
    $scheduledGames = <<EOM;
<td valign=top>
<table border=0>
  <tr>
    <td colspan=3 align=center>
<b>
Scheduled Games
</b>
    </td>
  </tr>
  <tr>
    <td align=right>
      Gold
    </td>
    <td align=center>
      &nbsp;
    </td>
    <td align=left>
      Silver
    </td>
  </tr>
  $scheduledGames
  $gameTimes
</table>
<td>
EOM
  }

  if ($finishedGames){
    $finishedGames = <<EOM;
<td valign=top>
<table border=0>
  <tr>
    <td colspan=3 align=center>
<b>
Results
</b>
    </td>
  </tr>
  <tr>
    <td align=right>
      Gold
    </td>
    <td align=center>
      &nbsp;
    </td>
    <td align=left>
      Silver
    </td>
  </tr>
  $finishedGames
  $clickOnBoard
</table>
<td>
EOM
  }

  $func = <<EOM;
    <script language="JavaScript1.2">
<!--
function playerPage(u){
    open('/arimaa/gameroom/playerpage.cgi?u='+u,'','toolbar=no,width=650,height=450,scrollbars=yes,directories=no,location=no,menubar=no,personalbar=no,resizable=no');
    void('');
}

function comPage(g){
    open('/arimaa/gameroom/comments.cgi?gid='+g,'','');
    void('');
}

function openGame(id, role, side){
  if (parseInt(id) > 0){
    open('/arimaa/games/showGame.cgi?gid='+id+'&s='+side,'','toolbar=no,width=350,height=250,scrollbars=no,directories=no,location=no,menubar=no,personalbar=no,resizable=no');
  }
  else{
    if (parseInt(id) == 0){
      alert("Game was won by forfeit");
    }
    else{
      alert("To watch the game login to the Arimaa gameroom and use 'Current Games'");
    }
  }
  void('');
}

// -->
    </script>
EOM


}


print <<EOM;
<html>
  <head><title>2004 Arimaa Computer Championship</title></head>
  <body bgcolor=#d8d8f8>
$func
    <center>
<p><font size=+2><b>2004 Arimaa Computer Championship</b></font>
<p>
    <table>
      <tr>
$scheduledGames
$finishedGames
$standings
      </tr>
    <table>
    </center>
  </body>
</html>

EOM



